'use strict';

chrome.runtime.onInstalled.addListener(function (details) {
  console.log('previousVersion', details.previousVersion);
});
chrome.tabs.onUpdated.addListener(function (tabId) {
  chrome.pageAction.show(tabId);
});
chrome.runtime.onMessage.addListener(function (request, sender, sendResponse) {
  if (request.contentScriptQuery == "bap") {
    var url = "https://www.lego.com/pl-pl/service/replacementparts/sale";
    fetch(url).then(function (response) {
      return response.text();
    }).then(function (html) {
      var el = document.createElement('html');
      el.innerHTML = html;
      var scripts = el.getElementsByTagName('script');
      var scriptURL = Array.from(scripts).find(function (item) {
        return item.src.includes('scripts.min.min');
      }).src;
      return fetch(scriptURL); //sendResponse(scriptURL);
    }).then(function (response) {
      return response.text();
    }).then(function (response) {
      var match = response.match('live:"https:\/\/bricksandpieces\.services\.lego\.com",key:"([A-Za-z0-9]+)"');
      var apiKey = match[1];
      var url = "https://bricksandpieces.services.lego.com/api/v1/bricks/items/" + encodeURIComponent(request.itemId) + "?country=PL&orderType=buy"; //sendResponse(url);

      return fetch(url, {
        "headers": {
          "x-api-key": apiKey
        }
      });
    }).then(function (response) {
      return response.json();
    }).then(function (response) {
      sendResponse(response);
    })["catch"](function (error) {
      return sendResponse(error);
    });
    return true; // Will respond asynchronously.
  } else if (request.contentScriptQuery == "pab") {
    fetch("https://www.lego.com/api/graphql/PickABrickQuery", {
      "headers": {
        "accept": "*/*",
        "content-type": "application/json",
        "x-locale": "pl-PL"
      },
      "body": "{\"operationName\":\"PickABrickQuery\",\"variables\":{\"page\":1,\"perPage\":100,\"query\":\"" + request.itemId + "\",\"icmp\":\"HP-SHQL-EG-NO-pick-a-120\",\"filters\":[]},\"query\":\"query PickABrickQuery($query: String, $page: Int, $perPage: Int, $filters: [Filter!]) {\\n  elements(query: $query, page: $page, perPage: $perPage, filters: $filters) {\\n    count\\n    facets {\\n      ...FacetData\\n      __typename\\n    }\\n    results {\\n      ...ElementLeafData\\n      __typename\\n    }\\n    total\\n    __typename\\n  }\\n  me {\\n    ... on LegoUser {\\n      ...UserData\\n      pabCart {\\n        PABLineItems {\\n          ...PABLineItemData\\n          __typename\\n        }\\n        taxedPrice {\\n          totalGross {\\n            currencyCode\\n            formattedAmount\\n            formattedValue\\n            __typename\\n          }\\n          __typename\\n        }\\n        __typename\\n      }\\n      __typename\\n    }\\n    __typename\\n  }\\n}\\n\\nfragment FacetData on Facet {\\n  id\\n  key\\n  name\\n  labels {\\n    count\\n    key\\n    name\\n    ... on FacetValue {\\n      value\\n      __typename\\n    }\\n    ... on FacetRange {\\n      from\\n      to\\n      __typename\\n    }\\n    __typename\\n  }\\n  __typename\\n}\\n\\nfragment ElementLeafData on Element {\\n  id\\n  name\\n  primaryImage\\n  spinsetMedia {\\n    frames {\\n      url\\n      __typename\\n    }\\n    __typename\\n  }\\n  ... on SingleVariantElement {\\n    variant {\\n      ...ElementLeafVariant\\n      __typename\\n    }\\n    __typename\\n  }\\n  ... on MultiVariantElement {\\n    variants {\\n      ...ElementLeafVariant\\n      __typename\\n    }\\n    __typename\\n  }\\n  __typename\\n}\\n\\nfragment ElementLeafVariant on ElementVariant {\\n  id\\n  price {\\n    currencyCode\\n    centAmount\\n    formattedAmount\\n    __typename\\n  }\\n  attributes {\\n    availabilityStatus\\n    canAddToBag\\n    colour\\n    colourFamily\\n    designNumber\\n    mainGroup\\n    materialGroup\\n    materialType\\n    maxOrderQuantity\\n    showInListing\\n    __typename\\n  }\\n  __typename\\n}\\n\\nfragment UserData on LegoUser {\\n  pabCart {\\n    id\\n    PABLineItems {\\n      id\\n      quantity\\n      element {\\n        id\\n        __typename\\n      }\\n      __typename\\n    }\\n    __typename\\n  }\\n  __typename\\n}\\n\\nfragment PABLineItemData on PABCartLineItem {\\n  id\\n  quantity\\n  element {\\n    id\\n    name\\n    primaryImage\\n    __typename\\n  }\\n  price {\\n    centAmount\\n    currencyCode\\n    __typename\\n  }\\n  elementVariant {\\n    id\\n    attributes {\\n      designNumber\\n      __typename\\n    }\\n    __typename\\n  }\\n  totalPrice {\\n    formattedAmount\\n    __typename\\n  }\\n  __typename\\n}\\n\"}",
      "method": "POST",
      "mode": "cors"
    }).then(function (response) {
      return response.json();
    }).then(function (response) {
      sendResponse(response);
    })["catch"](function (error) {
      return sendResponse(error);
    });
    return true;
  }
});
console.log('Brick Buyer hello!');