'use strict';

console.log('[BB] BL Catalog Entry');

function buildUI() {
  var injectedScript = document.createElement('script');
  injectedScript.innerText = '_ui_elems.tabMenu.appendTabMenu( "lego.com", "L" );';
  document.body.appendChild(injectedScript);
  var addLiitemsForSale = document.getElementById('_idTabContentsS');
  if (addLiitemsForSale == null) return;
  var container = addLiitemsForSale.parentNode;
  var div = document.createElement('div');
  div.id = '_idTabContentsL';
  div.className = 'pciTabContents';
  div.style = 'display: none;';
  container.insertBefore(div, addLiitemsForSale);
}

window.addEventListener('hashchange', function () {
  executeLegoPrice();
});

function getBlColor() {
  var colorElement = document.querySelector("#_idSelectColorContainer > div.pciSelectColorDropdown");
  return colorElement.getAttribute("data-color");
}

function getPartId() {
  var partId = document.querySelector("#id_divBlock_Main > table:nth-child(1) > tbody > tr:nth-child(1) > td > span > span").textContent;
  var re = /[a-z]$/;
  return partId.replace(re, "");
}

function fixColourName(rawColor) {
  return rawColor.replace("Red.", "Reddish ").replace("Br.", "Bright ").replace("Med.", "Medium ").replace("St-", "Stone ").replace("St.", "Stone").replace("R.", "Royal ").replace("Roy.", "Royal").replace("Bright Bluegreen", "Bright Bluish Green").replace("M.", "Medium ").replace("Md.", "Medium ").replace("Yel.", "Yellow ").replace("Yell.", "Yellowish ").replace("Spr.", "Spring ").replace("Do.", "Dove ").replace("Lgh.", "Light").replace("L.", "Light ").replace("Red-", "Reddish ").replace("Viol.", "Violet ").replace("Fl.", "Flame ").replace("Yel-", "Yellowish ").replace("Dk.", "Dark ").replace("Yell-", "Yellowish ").replace("Tr.", "Transparent ").replace("W.", "Warm ").replace("Orabrown", "Orange Brown").replace("Transparent Ml.Royal Viol", "Transparent Medium Reddish Violet").replace("Transparent Medium Royal V.Gli", "Transparent Medium Reddish Violet Glitter").replace(/Yel$/, "Yellow").replace(/Gree$/, "Green").replace(/Ora$/, "Orange").replace("-", " ").replace("  ", " ").replace("  ", " ").replace("  ", " ").replace(/ $/, "");
  ;
}

function executeLegoPrice() {
  var color = getBlColor();

  if (color != null) {
    var test = 1;
  }

  var legoPickABrick = document.getElementById('_idTabContentsL');
  var table = document.createElement('table');
  table.className = 'pciItemTable';
  table.style = 'font-family: Tahoma, Arial; font-size: 12px;';
  legoPickABrick.innerHTML = '';
  legoPickABrick.appendChild(table);
  var newRow = table.insertRow();
  newRow.className = 'pciItemHeader';
  newRow.insertCell(-1).appendChild(document.createTextNode("Image"));
  newRow.insertCell(-1).appendChild(document.createTextNode("Description"));
  var qty = newRow.insertCell(-1);
  qty.style = 'text-align: center;';
  qty.appendChild(document.createTextNode("Availability"));
  var seller = newRow.insertCell(-1);
  seller.style = 'text-align: right;';
  seller.appendChild(document.createTextNode("Seller"));
  var price = newRow.insertCell(-1);
  price.style = 'text-align: right;';
  price.appendChild(document.createTextNode("Price"));
  chrome.runtime.sendMessage({
    contentScriptQuery: 'bap',
    itemId: getPartId()
  }, function (bricks) {
    Array.from(bricks.bricks).forEach(function (item, index) {
      // Insert a row in the table at the last row
      var newRow = table.insertRow();
      newRow.className = 'ciItemContents ' + (index % 2 == 0 ? 'pciItemRowEven' : 'pciItemRowOdd');
      var newCell = newRow.insertCell(-1);
      var img = document.createElement('img');
      img.src = item.imageUrl;
      img.style.height = '60px';
      newCell.appendChild(img);
      newRow.insertCell(-1).innerHTML = '<b>' + item.description + '</b><br />' + item.itemNumber + '/' + item.designId + ' - ' + fixColourName(item.colorFamily) + ' (' + item.colorFamily + ')';
      var qty = newRow.insertCell(-1);
      qty.style = 'text-align: center;';
      qty.appendChild(document.createTextNode(item.isSoldOut ? ' Sold out' : item.isAvailable ? 'Available' : 'Not available'));
      var seller = newRow.insertCell(-1);
      seller.style = 'text-align: right;';
      seller.appendChild(document.createTextNode("B&P"));
      var price = newRow.insertCell(-1);
      price.style = 'text-align: right;';
      price.appendChild(document.createTextNode(item.price.currency + ' ' + (Math.round(item.price.amount * 100) / 100).toFixed(2)));
    });
  });
  chrome.runtime.sendMessage({
    contentScriptQuery: 'pab',
    itemId: getPartId()
  }, function (bricks) {
    Array.from(bricks.data.elements.results).forEach(function (item, index) {
      // Insert a row in the table at the last row
      var newRow = table.insertRow();
      newRow.className = 'ciItemContents ' + (index % 2 == 0 ? 'pciItemRowEven' : 'pciItemRowOdd');
      var newCell = newRow.insertCell(-1);
      var img = document.createElement('img');
      img.src = item.primaryImage;
      img.style.height = '60px';
      newCell.appendChild(img);
      newRow.insertCell(-1).innerHTML = '<b>' + item.name + '</b><br />' + item.variant.id + '/' + item.variant.attributes.designNumber + ' - ' + item.variant.attributes.colour;
      var qty = newRow.insertCell(-1);
      qty.style = 'text-align: center;';
      qty.appendChild(document.createTextNode(item.variant.attributes.canAddToBag ? 'Available' : 'Not available'));
      var seller = newRow.insertCell(-1);
      seller.style = 'text-align: right;';
      seller.appendChild(document.createTextNode("PaB"));
      var price = newRow.insertCell(-1);
      price.style = 'text-align: right;';
      price.innerHTML = item.variant.price.currencyCode + ' ' + (Math.round(item.variant.price.centAmount) / 100).toFixed(2) + '<br><input type="button" onclick="window.open(\'https://www.lego.com/pl-pl/page/static/Pick-a-Brick?page=1&filters.i0.key=variants.attributes.designNumber&filters.i0.values.i0=' + item.variant.attributes.designNumber + '&filters.i1.key=variants.attributes.exactColour.pl&filters.i1.values.i0=' + encodeURIComponent(item.variant.attributes.colour) + '\', \'_blank\');" class="blButton blButtonInput blButtonBlue bold" style="margin-top: 5px;" value="View">';
    });
  });
}

function executeSellerLocation(defaultSeller) {
  console.log('[BB] Default seller: ' + defaultSeller);

  if ('Disabled'.localeCompare(defaultSeller) != 0) {
    var words = defaultSeller.split(':');
    var type = words[0];
    var val = words[1];
    var radios = document.getElementsByName('inSellerLocation');

    for (var i = 0; i < radios.length; i++) {
      if (radios[i].value == type) radios[i].checked = true;
    }

    if ('C'.localeCompare(type) == 0) {
      var dropdown = document.getElementById('_idSelSellerCountry');
      dropdown.value = val;
    } else if ('R'.localeCompare(type) == 0) {
      var dropdown = document.getElementById('_idSelSellerRegion');
      dropdown.value = val;
    }

    var button = document.getElementById('_idbtnSearch2');
    button.click();
  }
}

function executeExpandMoreSettings() {
  var button = document.getElementById('_idMoreLink');
  button.click();
}

chrome.storage.sync.get({
  searchInventory: true,
  searchVariants: true,
  defaultSellerLocation: 'Anywhere',
  moreSettingsExpanded: false
}, function (items) {
  buildUI();
  executeLegoPrice();
  executeSellerLocation(items.defaultSellerLocation);
  if (items.moreSettingsExpanded) executeExpandMoreSettings();
});